package com.trs.project.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.time.LocalDateTime;


@Data
@TableName("risk_article_info")
public class RiskArticleInfo {

    @TableId
    private String irhkeybbsnum;//数据唯一值
    private String fullname;//信号企业全称
    private String pubtime;//发布时间
    private String title;//标题
    private String irsrcname;//文章来源
    private String trsabstract;//摘要
    private String trskeyworks;//关键词
    private String url;//文章链接
    private String sitename;//站点
    private String content;//站点
    private String channel;//栏目
    private String irauthors;//作者
    private String groupname;//分组名称 国内新闻 国内论坛 国内博客 APP
    private String trscustrisk;//企业客户风险
    private String trssimrank;//排重字段 判断正文是否重复 0为不重复数据 1为重复数据
    private String sid;//数据类型  1：新闻；2：微信；3：微博
    private String gst;//1,3代表信号，11代表准确数据
    private LocalDateTime savetime;
}

