package com.trs.project.entity;


import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.time.LocalDateTime;


@Data
@TableName("value_info")
public class ValueInfo {

    @TableId
    private String empId;//企业 id
    private String empCreditNo;//信用代码
    private String cylzs;//产业链招商
    private String advice;//推荐营销策略
    private String zhjz;//企业综合价值
    private String tzph;//投资偏好
    private String zskxxArr;//招商可行性（JSONString格式）
    private String yqyx;//舆情影响
    private String zskxxList;//招商可行性图（JSONString格式）
    private String rcgx;//人才贡献
    private String qzdj;//选址需求
    private String zscl;//招商策略（JSONString格式） blys：不利因素 gsld：公司亮点 ylys：有利因素
    private String cxnl;//创新能力
    private String ywzz;//业务增长
    private String zhjzList;//企业综合价值图（JSONString格式）
    private String nsnl;//纳税能力
    private String zjsl;//资金实力
    private String tzhyd;//投资活跃度
    private String zzdf;//资质荣誉
    private String zhjzArr;//企业综合价值（JSONString格式）
    private String zskxx;//招商可行性
    private LocalDateTime savetime;
}

