package com.trs.project.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.time.LocalDateTime;


@Data
@TableName("data_cleaning")
public class DataCleaning {
    @TableId
    private String irhkeybbsnum;//数据唯一值
    private String urldate;//发布日期
    private String pubtime;//发布时间
    private String source;//来源
    private String content;//正文
    private String title;//标题
    private String irsrcname;//文章来源
    private String url;//文章链接
    private String sitename;//站点
    private String channel;//频道
    private String irauthors;//作者
    private String groupname;//国内新闻、国内论坛、国内博客、APP
    private String resultstr;//企业客户风险
    private String trscustrisk;//企业客户风险
    private String trsarea;//地区分类
    private String trsindustry;//行业分类
    private String trskeyworks;//关键词
    private String trsabstract;//摘要
    private LocalDateTime savetime;//发布日期
}

