package com.trs.project.entity;


import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.time.LocalDateTime;


@Data
@TableName("justice_info")
public class Justice {

    @TableId
    private String empId;//企业 id
    private String empCreditNo;//信用代码
    private Integer fygg;//法院公告信息数量
    private Integer shixin;//失信公告信息数量
    private Integer ktgg;//开庭公告信息数量
    private Integer consumerResult;//限制高消费数量
    private Integer total;//所有信息数量
    private Integer cpws;//裁判文书信息数量
    private Integer terminationCaseResult;//终本案件数量
    private Integer lian;//立案信息数量
    private Integer zxgg;//执行公告信息数量
    private LocalDateTime savetime;//保存时间

}

