package com.trs.project.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.trs.project.entity.BusinessInfo;
import com.trs.project.mapper.BusinessInfoMapper;
import com.trs.project.service.BusinessInfoService;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service
public class BusinessInfoServiceImpl extends ServiceImpl<BusinessInfoMapper, BusinessInfo> implements BusinessInfoService {

    @Autowired
    private BusinessInfoMapper businessInfoMapper;

    @Override
    public int selectBusinessInfoIsTrue(String name) {
        return businessInfoMapper.selectBusinessInfoIsTrue(name);
    }
}
